if (0 == (*(pIn))) {
  *(pIn + pw) = (unsigned short)(32768);
  *(pIn + 2*pw) = (unsigned short)(32768);
  pIn += np;
  if ( pipeData->m_layerNum != 0 ) { pAlpha += np; }
  continue;
}

R = ((double) *(pIn))/((double) 652.80);
G = (((double)*(pIn + pw))
  -((double)32768.0))/((double)256.0);
B = (((double)*(pIn + 2*pw))
  -((double)32768.0))/((double)256.0);

double fy = (R+((double)16.0))/((double)116.0);
double fx = G/((double)500.0)+fy;
double fz = fy-B/((double)200.0);
double xr,yr,zr;
double fx3=fx*fx*fx;
double fz3=fz*fz*fz;
if(fx3>EPSILON) xr = fx3;
else xr = (((double)116.0)*fx-((double)16.0))/KAPPA;
if(fz3>EPSILON) zr = fz3;
else zr = (((double)116.0)*fz-((double)16.0))/KAPPA;
if(R>EPSILONKAPPA) {
  yr = ((R+((double)16.0))/((double)116.0));
  yr = yr*yr*yr;
} else yr = R/KAPPA;
double X = xr*white_x;
double Y = yr*white_y;
double Z = zr*white_z;

double little_x = X/(X+Y+Z);
double little_y = Y/(X+Y+Z);

// Exponential approximation
double n = (little_x-((double)0.3366))/(little_y-((double)0.1735));
double cct = ((double)-949.86315)
    + ((double)6253.80338)*exp(-n/((double)0.92159))
    + ((double)28.70599) * exp(-n/((double)0.20039))
    + ((double)0.00004)  * exp(-n/((double)0.07125));
if(cct>50000) {
  double n = (little_x-((double)0.3356))/(little_y-((double)0.1691));
  cct = ((double)36284.48953)
      + ((double)0.00228)*exp(-n/((double)0.07861))
      + ((double)5.4535e-36) * exp(-n/((double)0.01543));
}

if(cct<2500.0) cct = 2500.0;

double cct2 = cct*cct;
double cct3 = cct2*cct;
if(cct<=7000.0) {
  little_x = -4.6070e9/cct3+2.9678e6/cct2+0.09911e3/cct+0.244063;
} else {
  little_x = -2.0064e9/cct3+1.9018e6/cct2+0.24748e3/cct+0.237040;
}
little_y = -3.0*little_x*little_x+2.870*little_x-0.275;


// Compute spectral power distribution
double m = ((double)0.0241) + ((double) 0.2562)*little_x
                            - ((double) 0.7341)*little_y;
double m1 = (((double)-1.3515) - ((double) 1.7703)*little_x
                            + ((double) 5.9114)*little_y)/m;
double m2 = (((double)0.0300) - ((double) 31.4424)*little_x
                            + ((double) 30.0717)*little_y)/m;
R = normalize * (s1*m1 + s2*m2 + 1.0) * ((ychannel)?Y:R);

if(R<(double)0.0) R=(double)0.0;
if(R>(double)65280.0) R=(double)65280.0;
